#ifndef EFL_INPUT_DEVICE_IMPL_HH
#define EFL_INPUT_DEVICE_IMPL_HH

#include "efl_input_device.eo.hh"

namespace efl { namespace input { 
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Efl_Input_Device_Type>::type Device::device_type_get() const
{
    Efl_Input_Device_Type __return_value =  ::efl_input_device_type_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Input_Device_Type>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Device::device_type_set( ::efl::eolian::in_traits<Efl_Input_Device_Type>::type klass) const
{
     ::efl_input_device_type_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<Efl_Input_Device_Type,  ::efl::eolian::in_traits<Efl_Input_Device_Type>::type>(klass));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits< ::efl::input::Device>::type Device::source_get() const
{
     ::Efl_Input_Device* __return_value =  ::efl_input_device_source_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::input::Device>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Device::source_set( ::efl::eolian::in_traits< ::efl::input::Device>::type src) const
{
     ::efl_input_device_source_set(_eo_ptr(),
         ::efl::eolian::convert_to_c< ::Efl_Input_Device*,  ::efl::eolian::in_traits< ::efl::input::Device>::type>(src));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits< ::efl::input::Device>::type Device::seat_get() const
{
     ::Efl_Input_Device* __return_value =  ::efl_input_device_seat_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::input::Device>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits< unsigned int>::type Device::seat_id_get() const
{
    unsigned int __return_value =  ::efl_input_device_seat_id_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< unsigned int>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Device::seat_id_set( ::efl::eolian::in_traits< unsigned int>::type id) const
{
     ::efl_input_device_seat_id_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<unsigned int,  ::efl::eolian::in_traits< unsigned int>::type>(id));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::input::Device>>::type Device::children_iterate() const
{
    Eina_Iterator * __return_value =  ::efl_input_device_children_iterate(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::input::Device>>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits< unsigned int>::type Device::has_pointer_caps() const
{
    unsigned int __return_value =  ::efl_input_device_has_pointer_caps(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< unsigned int>::type>(__return_value);
}
#endif
} } 
namespace eo_cxx {
namespace efl { namespace input { 
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Efl_Input_Device_Type>::type Device::device_type_get() const
{
    Efl_Input_Device_Type __return_value =  ::efl_input_device_type_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Input_Device_Type>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Device::device_type_set( ::efl::eolian::in_traits<Efl_Input_Device_Type>::type klass) const
{
     ::efl_input_device_type_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<Efl_Input_Device_Type,  ::efl::eolian::in_traits<Efl_Input_Device_Type>::type>(klass));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits< ::efl::input::Device>::type Device::source_get() const
{
     ::Efl_Input_Device* __return_value =  ::efl_input_device_source_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::input::Device>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Device::source_set( ::efl::eolian::in_traits< ::efl::input::Device>::type src) const
{
     ::efl_input_device_source_set(_eo_ptr(),
         ::efl::eolian::convert_to_c< ::Efl_Input_Device*,  ::efl::eolian::in_traits< ::efl::input::Device>::type>(src));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits< ::efl::input::Device>::type Device::seat_get() const
{
     ::Efl_Input_Device* __return_value =  ::efl_input_device_seat_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::input::Device>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits< unsigned int>::type Device::seat_id_get() const
{
    unsigned int __return_value =  ::efl_input_device_seat_id_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< unsigned int>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Device::seat_id_set( ::efl::eolian::in_traits< unsigned int>::type id) const
{
     ::efl_input_device_seat_id_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<unsigned int,  ::efl::eolian::in_traits< unsigned int>::type>(id));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::input::Device>>::type Device::children_iterate() const
{
    Eina_Iterator * __return_value =  ::efl_input_device_children_iterate(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::input::Device>>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits< unsigned int>::type Device::has_pointer_caps() const
{
    unsigned int __return_value =  ::efl_input_device_has_pointer_caps(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits< unsigned int>::type>(__return_value);
}
#endif
inline efl::input::Device::operator ::efl::input::Device() const { return *static_cast< ::efl::input::Device const*>(static_cast<void const*>(this)); }
inline efl::input::Device::operator ::efl::input::Device&() { return *static_cast< ::efl::input::Device*>(static_cast<void*>(this)); }
inline efl::input::Device::operator ::efl::input::Device const&() const { return *static_cast< ::efl::input::Device const*>(static_cast<void const*>(this)); }
} } }
#endif
